#include <stdbool.h>
#include <stdarg.h>
#include <stdint.h>
#include <time.h>

extern void   HttpAddChar       (char c);
extern void   HttpFillChar      (char c, int length);
extern int    HttpAddText       (const char* text);
extern int    HttpAddV          (char *fmt, va_list argptr);
extern int    HttpAddF          (char *fmt, ...);
extern void   HttpAddData       (const char* data, int length);
extern void   HttpAddStream     (void (*startFunction)(void), int (*enumerateFunction)(void));
extern void   HttpAddNibbleAsHex(int value);
extern void   HttpAddByteAsHex  (int value);
extern void   HttpAddInt12AsHex (int value);
extern void   HttpAddInt16AsHex (int value);
extern void   HttpAddInt32AsHex (int value);
extern void   HttpAddInt64AsHex (int64_t value);
extern void   HttpAddTm         (struct tm* ptm);
extern bool   HttpBufFilled     (void);

extern void   HttpOk(const char* contentType, const char* cacheControl, const char* lastModifiedDate, const char* lastModifiedTime);
extern char*  HttpOkCookieName;
extern char*  HttpOkCookieValue;
extern int    HttpOkCookieMaxAge;

extern void   HttpNotFound      (void);
extern void   HttpNotModified   (void);

extern int    HttpRequestRead  (char *p, int len, char** ppMethod, char** ppPath, char** ppQuery, char** ppLastModified, char** ppCookies, int* pContentLength);

extern char*  HttpCookiesSplit   (char* pCookies, char** ppName, char** ppValue);
extern char*  HttpQuerySplit     (char* pQuery,   char** ppName, char** ppValue);
extern int    HttpQueryValueAsInt(char* pValue);
extern void   HttpQueryUnencode  (char* pValue);

extern bool   HttpTrace;

extern void   HttpDateFromDateTime(const char* date, const char *ptime, char* ptext);
extern void   HttpDateFromNow(char* pText);

extern bool HttpSameStr               (const char* pa,   const char* pb);
extern bool HttpSameStrCaseInsensitive(const char* pa,   const char* pb);
extern bool HttpSameDate              (const char* date, const char* time, const char* pOtherDate);

#define HTTP_DATE_LENGTH 30

extern void (*HttpRequestFunction)(char* pState, int size, char* pRequestStream, uint32_t positionInRequestStream);
extern int  (*HttpPollFunction   )(char* pState, bool clientFinished);
extern bool (*HttpReplyFunction  )(char* pState);

